#-Everything in this file is organized alphabetically, EVENTS first, ALIASES
#-second, and PROCEDURES last.  Special thanks to hero- for large amounts of
#-the cool parts of this script.  Way to go hero!

#-EVENTS

proc event_dcc_accept { args } {
    if { [lindex $args 0]=="chat" } {
	set wn .dccaccept[lindex $args 1]
	toplevel $wn
	wm title $wn "DCC Chat Accept Query"
	pack [message $wn.message -text "[lindex $args 2] wishes to chat with you at [lindex $args 3]:[lindex $args 4].  Do you accept?" -width 300]
	bind $wn <KeyPress-Return> "::template::acceptlist [index] accept [lindex $args 1]; destroy $wn"
	bind $wn <KeyPress-Escape> "::template::acceptlist [index] reject [lindex $args 1]; destroy $wn"
	pack [button $wn.buttonyes -text "yes" -default active -command "::template::acceptlist [index] accept [lindex $args 1]; destroy $wn"] -side left
	pack [button $wn.buttonno -text "no" -command "::template::acceptlist [index] reject [lindex $args 1]; destroy $wn"] -side right
    }
    if { [lindex $args 0]=="send" } {
	set exists 0
        if { [file exists $::dynamic::dcc_directory/[lindex $args 5]] } {
	    set exists 1
	}
	if { $::dynamic::dcc_auto_accept && !$exists } {
	    acceptlist accept [lindex $args 1]
	    return
	}
	if { $::dynamic::dcc_auto_accept && $exists && $::dynamic::dcc_auto_overwrite } {
	    acceptlist overwrite [lindex $args 1]
	    return
	}
	set wn .dccaccept[lindex $args 1]
	toplevel $wn
	wm title $wn "DCC File Accept Query"
	set yes "::template::acceptlist [index] accept [lindex $args 1]; destroy $wn"
	set no "::template::acceptlist [index] reject [lindex $args 1]; destroy $wn"
	set yestext "Yes"
	set notext "No"
	if { $exists } {
	    set yes "::template::acceptlist [index] overwrite [lindex $args 1]; destroy $wn"
	    set no "::template::acceptlist [index] reject [lindex $args 1]; destroy $wn"
	    set yestext "Yes (Overwrite)"
	    set notext "No"
	}
	#-           $::dcc_auto_accept
	#-           $::dcc_auto_overwrite
	#-           $::dcc_auto_rename
	#-           $::dcc_auto_resume
	#-           Rename overides overwrite.  Resume overwrides rename unless the
	#-           file is the same size or smaller.
	#-           -What about mutual exclusivity here?
	#-	    pack [message $wn.message -text "[lindex $args 2] wishes to send you [lindex $args 5] with size [lindex $args 6] from [lindex $args 3]:[lindex $args 4].  Do you accept?" -width 300]
	pack [message $wn.message -text "[lindex $args 2] wishes to send you [lindex $args 5] with size [lindex $args 6] from [lindex $args 3]:[lindex $args 4].  Do you accept?" -width 300]
	if { !$exists } { bind $wn <KeyPress-Return> $yes }
	bind $wn <KeyPress-Escape> $no
	pack [button $wn.buttonyes -text $yestext -default active -command $yes] -side left
	if { $exists } {
	    frame $wn.renframe
	    pack [entry $wn.renframe.entry]
	    pack [button $wn.renframe.button -text "Yes (Rename)" -command "::template::acceptlist [index] rename [lindex $args 1] \[$wn.renframe.entry get]; destroy $wn"]
	    $wn.renframe.entry insert 0 [lindex $args 5]
	    pack $wn.renframe -side left -padx 10
	    bind $wn <KeyPress-Return> "::template::acceptlist [index] rename [lindex $args 1] \[$wn.renframe.entry get]; destroy $wn"
	    focus $wn.renframe.entry
	}
	pack [button $wn.buttonno -text $notext -command $no] -side right
    }
    bind $wn <Destroy> "::template::acceptlist [index] reject [lindex $args 1]; destroy $wn"
    return 0
}

proc event_join { prefix channel args } {
    if { [lindex [split $prefix "!"] 0]==[mynick] } {
	set chan [string tolower $channel]
	set ::[index]::banlist($chan) ""
	set ::[index]::banwho($chan) ""
	set ::[index]::bantime($chan) ""
	lappend ::[index]::blistq $chan
	lappend ::[index]::wlistq $chan
	quote "MODE $chan +b"
        quote "MODE $chan"
	quote "WHO $chan"
    }
}

proc event_mode+b { args } {
    set chan [string tolower [lindex $args 1]]
    regsub \\. $chan -DOT- pathchan
    lappend ::[index]::banlist($chan) [lindex $args 2]
    lappend ::[index]::bantime($chan) [clock seconds]
    lappend ::[index]::banwho($chan) [lindex $args 0]
    if { [winfo exists .bans([index]+$pathchan)] == 1 } {
	.bans([index]+$pathchan).f.blist delete 0 end
	update_gblist [lindex $args 1]
    }
    return 0
}

proc event_mode-b { args } {
    set chan [string tolower [lindex $args 1]]
    regsub \\. $chan -DOT- pathchan
    set index [lsearch -exact [string tolower [set ::[index]::banlist($chan)]] [string tolower [lindex $args 2]]]
    set ::[index]::banlist($chan) [lreplace [set ::[index]::banlist($chan)] $index $index]
    set ::[index]::bantime($chan) [lreplace [set ::[index]::bantime($chan)] $index $index]
    set ::[index]::banwho($chan) [lreplace [set ::[index]::banwho($chan)] $index $index]
    if { [winfo exists .bans([index]+$pathchan)] == 1 } {
	.bans([index]+$pathchan).f.blist delete 0 end
	update_gblist [lindex $args 1]
    }
    return 0
}

proc event_privmsg { prefix args } {
    set nick [lindex [split $prefix "!"] 0]
    set message [lindex $args 1]

    if { [string index $message 0]=="\x01" && ![set ::[index]::ctcp_cloak] } {
	if { [string index $message [expr [string length $message]-1]]=="\x01" } {
	    set message [string range $message 1 [expr [string length $message]-2]]
	} else {
	    set message [string range $message 1 end]
	}
	switch -- [string toupper [lindex [split $message " "] 0]] {
	    "PING" {
		quote "NOTICE $nick :\x01$message\x01"
	    }
	    "VERSION" {
		quote "NOTICE $nick :\x01VERSION QuIRC v[version] (For *nix) - http://quirc.org/\x01"
	    }
	    "TIME" {
		quote "NOTICE $nick :\x01TIME [clock format [clock seconds]]\x01"
	    }
	    "DCC" {
		set filename [lindex [split $message " "] 2]
		set templist [string tolower [split $message " "]]
		if { [llength $templist]==5 } {
		    if {[lindex $templist 1]=="chat"&&[lindex $templist 2]=="chat"} {
			acceptlist add chat $nick [lindex $templist 3] [lindex $templist 4]
		    }
		    if {[lindex $templist 1]=="send"} {
			acceptlist add file $nick [lindex $templist 3] [lindex $templist 4] $filename
		    }
		}
		if { [llength $templist]>=6 } {
		    if {[lindex $templist 1]=="send"} {
			acceptlist add send $nick [lindex $templist 3] [lindex $templist 4] $filename [lindex $templist 5]
		    }
		}
	    }

	}
    }
    return 0
}

proc event_raw_unparsed { data } {
    if { $::dynamic::do_rawview } {
	.raw.text insert end "$data\n"
    }
}

proc event_001 { prefix args } {
    if { ![winfo exists .buttonbar.lag] } {
	pack [label .buttonbar.lag -foreground $::lag_foreground -background $::lag_background] -side right
    }
    if { $::dynamic::lag_time!=0 } {
	quote "PING [microtime]"
    }
    if { $::dynamic::auto_rejoin } {
	set channels ""
	set keys ""
	foreach channel [channels] {
	    set key [channelmode k $channel]
	    if { $key=="" } {
		lappend channels $channel
	    } else {
		set channels [linsert $channels 0 $channel]
		set keys [linsert $keys 0 $key]
	    }
	}
	if { $channels!="" } { quote "JOIN [join $channels ,] [join $keys ,]" }
    }
    if { [info exists ::[index]::auto_start] } {
	eval [set ::[index]::auto_start]
	unset ::[index]::auto_start
    }
    return 0
}

proc event_004 { prefix args } {
    if { $::dynamic::rename_servers } {
	renamewindow [pathname status] [lindex $args 1]
    }
}

proc event_367 { args } {
    set chan [string tolower [lindex $args 2]]
    if { [info exists ::[index]::blistq] &&
         [lsearch -exact [set ::[index]::blistq] $chan] >= 0 } {
	lappend ::[index]::banlist($chan) [lindex $args 3]
	lappend ::[index]::bantime($chan) [lindex $args 5]
	lappend ::[index]::banwho($chan)  [lindex $args 4]
	return 2
    }
}


proc event_368 { args } {
    set chan [string tolower [lindex $args 2]]
    if { [info exists ::[index]::blistq] &&
         [lsearch -exact [set ::[index]::blistq] $chan] >= 0 } {
	set ::[index]::blistq [lreplace [set ::[index]::blistq] [lsearch -exact [set ::[index]::blistq] $chan] [lsearch -exact [set ::[index]::blistq] $chan]]
	return 2
    }
}

proc event_433 { args } {
    if { [lindex $args 2] == $::dynamic::default_nick } {
 	quote "NICK $::dynamic::default_altnick1"
    } elseif { [lindex $args 2] == $::dynamic::default_altnick1 } {
 	quote "NICK $::dynamic::default_altnick2"
    }
    return 0
}

# ALIASES

# /ame [-one] <message>
#     Sends an action to all the channels you are currently joined.  If -one is
#     specified, it will send to only the current server, otherwise it will
#     send to all open servers.  (If you would like to improve this alias,
#     you could add options to message queries and chat windows as well.)
alias ame {
    set one 0
    set rest $arg
    if { [lindex [split $arg " "] 0] == "-one" } {
	set one 1
	set rest [lrange [split $arg " "] 1 end]
    }
    if { $one } {
	foreach channel [channels] {
	    quote "PRIVMSG $channel :\001ACTION $rest\001"
	    echo "\0032* [mynick] $rest" [pathname channel $channel] 0
	}
    } else {
	foreach server [servers] {
	    evalserver $server "
		foreach \channel \[channels] {
	            quote \"PRIVMSG \$channel :\\001ACTION [escape $rest]\\001\"
	            echo \"\0032* \[mynick] [escape $rest]\" \[pathname channel \$channel] 0
		}
	    "
	}
    }
}

# /amsg [-one] <message>
#     Sends a message to all the channels you are currently joined.  If -one is
#     specified, it will send to only the current server, otherwise it will
#     send to all open servers.  (If you would like to improve this alias,
#     you could add options to message queries and chat windows as well.)
alias amsg {
    set one 0
    set rest $arg
    if { [lindex [split $arg " "] 0] == "-one" } {
	set one 1
	set rest [lrange [split $arg " "] 1 end]
    }
    if { $one } {
	foreach channel [channels] {
	    say $rest [pathname channel $channel]
	}
    } else {
	foreach server [servers] {
	    evalserver $server "
		foreach \channel \[channels] {
		    say [escape $rest] \[pathname channel \$channel]
		}
	    "
	}
    }
}

# /away [-one|-all] [<reason>]
#     If a reason is given, sets you away on the server(s).  If no reason is
#     given, sets you not away on the given server(s).  If -one is specified,
#     the away command will only apply to the current server, otherwise it
#     will apply to all running servers.  -all is the same as not specifying
#     an option.
alias away {
    set command [string tolower [lindex [split $arg " "] 0]]
    if { $command=="-one" || $command=="-all" } {
	set rest [join [lrange [split $arg " "] 1 end]]
	if { $command=="-one" } {
	    quote "AWAY :$rest"
	} else {
	    foreach server [servers] {
		evalserver $server "quote \"AWAY :$rest\""
	    }
	}
    } else {
	foreach server [servers] {
	    evalserver $server "quote \"AWAY :$arg\""
	}
    }
}

# /ban [<channel>] <nick or mask> [<type>]
#    Bans the given nick from the given, or current, channel.  If no type is
#    given, type 3 (*!*user@*.domain.name) is assumed.  If the nick contains
#    the ! character, it will simply ban it, ignoring any given type.
alias ban {
    eval "ban $arg"
}

# /bk <nick> [<reason>]
#     Bans, then kicks the given nick from the current channel using the given
#     reason.
alias bk {
    set nick [lindex [split $arg " "] 0]
    set reason [join [lrange [split $arg " " ] 1 end]]
    quote "mode [channel] +b [mask 3 $nick![userhost $nick ]]"
    quote "kick [channel] $nick :$reason"
}

# /blist
#     Displays the ban list for the current channel.
alias blist {
    set chan [string tolower [channel]]
    set bans [set ::[index]::banlist($chan)]
    set bnicks [set ::[index]::banwho($chan)]
    set btime ""
    foreach time [set ::[index]::bantime($chan)] {
	lappend btime [clock format $time]
    }
    echo [format "\0030,7 %-3s \0030,3 %-[max 3 [llongest $bans]]s \0030,2 %-[max 4 [llongest $bnicks]]s \0030,6 %-[max 4 [llongest $btime]]s " "Num" "Ban" "Nick" "Time"]
    if { [llength $bans] == 0 } { echo "The ban list is empty." }
    for { set i 0 } { $i < [llength $bans] } { incr i } {
	echo [format " %-3s  %-[max 3 [llongest $bans]]s  %-[max 4 [llongest $bnicks]]s  %-[max 4 [llongest $btime]]s" [expr $i + 1] [lindex $bans $i] [lindex $bnicks $i] [lindex $btime $i]]
    }
}

# /c [<channel>] [-/+]<mode letter(s)> [<mode parameter> ...]
#     Changed the mode on the given, or current, channel.  If no sign is
#     specified, + is assumed.  This command may not work properly in channel
#     names that start with +.
alias c {
    set chan [lindex [split $arg " "] 0]
    if { [string index $chan 0]!="#" && [string index $chan 0]!="&" } {
	set arg [join [linsert [split $arg " "] 0 [channel]]]
    }
    set list [split $arg " "]
    if { [string index [lindex $list 1] 0]!="+" && [string index [lindex $list 1] 0]!="-" } {
	quote "MODE [lindex $list 0] +[join [lrange $list 1 end]]"
    } else {
	quote "MODE [lindex $list 0] [join [lrange $list 1 end]]"
    }
}

# /calc $<variable name>|<expression>
#     If a variable is given (ex. $::tcl_patchLevel), show the value of that
#     variable.  If an expression is given (ex. 5+[string length "whee"]),
#     evaluate it using TCL's expr.
alias calc {
    if { [string first $arg " "]==-1 && [string index $arg 0]=="\$" } {
	say "QuICK Recall: $arg = [set [string range $arg 1 end]]"
    } else {
	say "QuICK Calc: $arg = [expr $arg]"
    }
}

# /channel [<channel>[,<channel>...] [<key>[,<key>...]]]
#     Alias for /join.
alias channel {
    /join $arg
}

# /cloak
#     Makes QuIRC ignore all CTCP requests (including DCC).  /decloak reverses.
#     This is a server specific setting and affects the current server.
alias cloak {
    set ::[index]::ctcp_cloak 1
    echo " \0030,14 CLOAK \003 Engaging Cloaking System"
}

# /colors [-say]
#     An alias for /colours.
alias colors {
    /colours $arg
}


# /colours [-say]
#     If -say is specified, it will output a colour chart to the current
#     channel, query, or chat.  Otherwise, it will just display the chart.
alias colours {
    if { $arg=="-say" } {
	say "0 0 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 10 10 11 11 12 12 13 13 14 14 15 15 "
	say "1,0 0 0,1 1 1,2 2 1,3 3 1,4 4 1,5 5 1,6 6 1,7 7 1,8 8 1,9 9 1,10 10 1,11 11 1,12 12 1,13 13 1,14 14 1,15 15 "
    } else {
	echo "0 0 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 10 10 11 11 12 12 13 13 14 14 15 15 "
	echo "1,0 0 0,1 1 1,2 2 1,3 3 1,4 4 1,5 5 1,6 6 1,7 7 1,8 8 1,9 9 1,10 10 1,11 11 1,12 12 1,13 13 1,14 14 1,15 15 "
    }
}

proc alias_ctcp { arg } {
    quote "PRIVMSG [lindex [split $arg " "] 0] :\x01[join [lrange [split $arg " "] 1 end]]\x01"
}

proc alias_ctcpreply { arg } {
    quote "NOTICE [lindex [split $arg " "] 0] :\x01[join [lrange [split $arg " "] 1 end]]\x01"
}

proc alias_cycle { arg } {
    quote "PART [channel]"
    quote "JOIN [channel] [channelmode k [channel]]"
}

proc alias_dcc { arg } {
    set arglist [split $arg " "]
    if { [llength $arglist]>2 && [string length [lindex $arglist 2]]>0 } {
	set filename [join [lrange $arglist 2 end]]
	if { [string index $filename 0]=="\"" && [string index $filename [expr [string length $filename]-1]]=="\"" } {
	    set filename [string range $filename 1 [expr [string length $filename]-2]]
	}
	set filename [lindex [glob $filename] 0]
	set arglist [lreplace $arglist 2 end $filename]
    }
    if { [llength $arglist]>2 && [lindex $arglist 2]=="" } {
	set arglist [lreplace $arglist 2 end]
    }
    callproc ::template::dcc $arglist [index]
}

# /decloak
#     Turns off cloaking for the current server.
alias decloak {
    set ::[index]::ctcp_cloak 0
    echo " \0030,14 CLOAK \003 Dropping Cloak"
}

# /deop <nick> [<nick> ...]
#     Deops the given nicks in the current channel.
alias deop {
    foreach nick [split $arg] {
	modequeue add [channel] -o $nick
    }
    modequeue flush [channel]
}

# /devoice <nick> [<nick> ...]
#     Devoices the given nicks in the current channel.
alias devoice {
    foreach nick [split $arg] {
	modequeue add [channel] -v $nick
    }
    modequeue flush [channel]
}

# /fixnicklist
#     On some occaisions due to the limitations of the IRC protocol, the
#     nicklist display for voiced people will become incorrect.  This
#     alias allows you to retrieve a new corrected nicklist from the NAMES
#     response.
alias fixnicklist {
    fixnicklist [channel]
}

# /fk <mask> [<reason>]
#     Kicks anyone in the channel who's nick!user@host matches the given mask.
#     If a reason is given, it is provided.  The mask may contain any of the
#     following wildcards: ? * [chars] (\ to escape).
alias fk {
    set mask [string tolower [lindex [split $arg " "] 0]]
    set reason [join [lrange [split $arg " "] 1 end]]
    if { [string length $reason] > 0 } { set reason " \[$reason]" }
    foreach nick [nicks [channel]] {
 	if { [string match $mask [string tolower $nick![userhost $nick]]] && $nick != [mynick] } {
 	    quote "KICK [channel] $nick :filter: $mask$reason" }
    }
}

# /gblist
#     Displays a graphical ban list for the current channel.  New bans may be
#     added by entering a space seperated list of masks into the entry box.
#     Bans can be removed by optionally selecting some, and then right
#     clicking on them.
alias gblist {
    regsub \\. [string tolower [channel]] -DOT- chan
    set cur [currentindex]
    if { [winfo exists .bans($cur+$chan)] } {
	destroy .bans($cur+$chan)
    } else {
	# Toplevel Ban Window
	toplevel .bans($cur+$chan)

	# Banlist Label
	label .bans($cur+$chan).top -font $::theme_banlist_font -relief groove -anchor w -bg $::theme_banlist_title_background -fg $::theme_banlist_title_foreground

	# Banlist and Scrollbar
	frame .bans($cur+$chan).f
	listbox .bans($cur+$chan).f.blist -font $::theme_banlist_font -relief flat -bg $::theme_banlist_background -fg $::theme_banlist_foreground -yscroll ".bans($cur+$chan).f.blist_vscroll set" -exportselection no -selectmode extended
	scrollbar .bans($cur+$chan).f.blist_vscroll -command ".bans($cur+$chan).f.blist yview"

	# Entry Box
	entry .bans($cur+$chan).add -font $::theme_banlist_font -relief groove -bg $::theme_banlist_entry_background -fg $::theme_banlist_entry_foreground -insertbackground $::theme_banlist_entry_insertbackground

	# If the right mouse button is hit, if there are zero or one things
        # selected, select the one just hit.  If there are more than one things
        # selected, add the current thing on.  Then send remove bans for all
        # of the selected items.
	bind .bans($cur+$chan).f.blist <Button-3> "
	    if { \[llength \[.bans($cur+$chan).f.blist curselection]]<2 } {
		.bans($cur+$chan).f.blist selection clear 0 end
		.bans($cur+$chan).f.blist selection set @%x,%y
	    } else {
		.bans($cur+$chan).f.blist selection set @%x,%y
	    }
	    foreach idx \[.bans($cur+$chan).f.blist curselection] {
                ::template::modequeue $cur add [channel] -b \[lindex \[set ::${cur}::banlist([string tolower [channel]])] \$idx]
            }
            ::template::modequeue $cur flush [channel]
        "
	bind .bans($cur+$chan).add <Return> "
           foreach ban  \[split \[.bans($cur+$chan).add get]] {
	       ::template::modequeue $cur add [channel] +b \$ban
           }
           ::template::modequeue $cur flush [channel]
           .bans($cur+$chan).add delete 0 end
        "

	# Pack header, list/scroll, and buttons/entry
	pack .bans($cur+$chan).top -fill x

	pack .bans($cur+$chan).f.blist -side left -expand yes -fill both
	pack .bans($cur+$chan).f.blist_vscroll -fill y -expand yes
	pack .bans($cur+$chan).f -fill both -expand yes

	pack .bans($cur+$chan).add -fill x

	#Bring initial focus to entry widget.
        focus .bans($cur+$chan).add

	# Fill the banlist, and set the window title and header.
	update_gblist [channel]
    }
    return 0
}

proc alias_invite { arg } {
    if { ![ischannel [lindex [split $arg " "] 1]] } { set arg [join [linsert [split $arg " "] 1 [channel]]] }
    quote "INVITE $arg"
}

# /j [<channel>[,<channel>...] [<key>[,<key>...]]]
#     Alias for /join.
alias j {
    /join $arg
}

# /join [<channel>[,<channel>...] [<key>[,<key>...]]]
#     Joins the given channels using the given keys.  If there are less keys
#     provided than channels, the keys will apply to the first channels.  If
#     no arguments are given, it will join the current channel.
alias join {
    if { $arg=="" } { set arg [channel] }
    if { ![ischannel [lindex [split $arg " "] 0]] } { set arg "#$arg" }
    quote "JOIN $arg"
}

# /k [<channel>] <nick> [<reason>]
#     Alias for /kick.
alias k {
    /kick $arg
}

# /kb <nick> [<reason>]
#     Kicks, then bans the given nick from the current channel using the given
#     reason.
alias kb {
    set nick [lindex [split $arg " "] 0]
    set reason [join [lrange [split $arg " " ] 1 end]]
    quote "kick [channel] $nick :$reason"
    quote "mode [channel] +b [mask 3 $nick![userhost $nick ]]"
}

# /kick [<channel>] <nick> [<reason>]
#     Kicks the given user off the given, or current, channel using the given
#     reason.
alias kick {
    if { ![ischannel [lindex [split $arg " "] 0]] } { set arg [join [linsert [split $arg " "] 0 [channel]]] }
    quote "KICK [join [lrange [split $arg " "] 0 1]] :[join [lrange [split $arg " "] 2 end]]"
}

# /mb [<channel>]
#     Bans everyone, but you, in the given, or current, channel.
alias mb {
    if { $arg=="" } { set arg [channel] }
    foreach nick [nicks $arg] {
	if { $nick != [mynick] } {
	    queueban $arg $nick
        }
    }
    modequeue flush $arg
}

# /mdop [<channel>]
#     Deops everyone, but you, in the given, or current, channel.
alias mdop {
    if { $arg=="" } { set arg [channel] }
    foreach nick [nicks $arg] {
	if { $nick!=[mynick] && [isop $nick $arg] } {
	    modequeue add $arg -o $nick
	}
    }
    modequeue flush $arg
}

# /me <action>
#      Performs the given action in the current window (channel/query/chat)
#      i.e. it sends a CTCP ACTION command. (* Somebody does something.)
alias me {
    if { [currentwindow]==".main" } { return }
    if { [string match ".chat*" [currentwindow]] } {
	dccquote [windowname] "\001ACTION $arg\001"
    } else {
	if { [string match ".status*" [currentwindow]] } { return }
	quote "PRIVMSG [windowname] :\001ACTION $arg\001"
    }
    echo "\0032* [mynick] $arg"
}

# /mop [<channel>]
#     Ops everyone in the given, or current, channel who isn't already an op.
alias mop {
    if { $arg=="" } { set arg [channel] }
    foreach nick [nicks $arg] {
	if {![isop $nick $arg]} {
	    modequeue add $arg +o $nick
	}
    }
    modequeue flush $arg
}

proc alias_msg { arg } {
    quote "PRIVMSG [lindex [split $arg " "] 0] :[join [lrange [split $arg " "] 1 end]]"
    if { [pathname query [lindex [split $arg " "] 0]]!="" } {
	echo [pathname query [lindex [split $arg " "] 0]] 0 "\0032<[mynick]>\003 [join [lrange [split $arg " "] 1 end]]"
    } else {
	echo "\0032*[lindex [split $arg " "] 0]*>\003 [join [lrange [split $arg " "] 1 end]]"
    }
}

# /mub [<channel>]
#     Clears the banlist for the given, or current, channel.
alias mub {
    if { $arg=="" } { set arg [channel] }
    foreach ban [set ::[index]::banlist([string tolower $arg])] {
	modequeue add $arg -b $ban
    }
    modequeue flush $arg
}

# /muv [<channel>]
#     De-voices everyone in the given, or current, channel.
alias muv {
    if { $arg=="" } { set arg [channel] }
    foreach nick [nicks $arg] {
	modequeue add $arg -v $nick
    }
    modequeue flush $arg
}

# /mv [<channel>]
#     Voices everyone who isn't already voiced in the given, or current,
#     channel.
alias mv {
    if { $arg=="" } { set arg [channel] }
    foreach nick [nicks $arg] {
	if {![isvoice $nick $arg]} {
	    modequeue add $arg +v $nick
	}
    }
    modequeue flush $arg
}

proc alias_notice { arg } {
    quote "NOTICE [lindex [split $arg " "] 0] :[join [lrange [split $arg " "] 1 end]]"
    echo "\0032-[lindex [split $arg " "] 0]->\003 [join [lrange [split $arg " "] 1 end]]"
}

proc alias_op { arg } {
    quote "MODE [channel] +oooooo $arg"
}

# /ops <message>
#     Sends a notice to @#channel where #channel is the current channel window.
alias ops {
    quote "NOTICE @[channel] :$arg"
    echo [currentwindow] 0 "\0036-@#UofACS->\003 $arg"
}

proc alias_part { arg } {
    if { ![ischannel [lindex [split $arg " "] 0]] } { set arg [join [linsert [split $arg " "] 0 [channel]]] }
    if { [join [lrange [split $arg " "] 1 end]]=="" } {
        quote "PART [lindex [split $arg " "] 0]"
    } else {
        quote "PART [lindex [split $arg " "] 0] :[join [lrange [split $arg " "] 1 end]]"
    }
}

proc alias_ping { arg } {
    quote "PRIVMSG [lindex [split $arg " "] 0] :\x01PING [microtime]\x01"
}

proc alias_query { arg } {
    set nick [lindex [split $arg " "] 0]
    set message [join [lrange [split $arg " "] 1 end]]
    createquery $nick
    if { $message!="" } { say $message }
}

proc alias_quit { arg } {
    if { $arg!="" } {
	quote "QUIT :$arg"
    } else {
	quote "QUIT :$::dynamic::default_quit"
    }
}

proc alias_quote { arg } {
    quote $arg
}

# /reload <script>
#     Simply unloads and then reloads the given script.
alias reload {
    unscript $arg
    script $arg
}

# /say <something>
#     Says something to the current channel, query or DCC.
alias say {
    say $arg
}

# /sv
#     Shows the client version and machine information to the current session.
alias sv {
    say "\x02QuIRC [version]\x02 - [exec uname -s] [exec uname -r] ([exec uname -m])"
}

proc alias_topic { arg } {
    if { ![ischannel [lindex [split $arg " "] 0]] } { set arg [join [linsert [split $arg " "] 0 [channel]]] }
    if { [join [lrange [split $arg " "] 1 end]]=="" } {
        quote "TOPIC [lindex [split $arg " "] 0]"
    } else {
        quote "TOPIC [lindex [split $arg " "] 0] :[join [lrange [split $arg " "] 1 end]]"
    }
}

proc alias_unban { arg } {
    if { [string first "!" $arg] > -1 } {
        set umask $arg
    } elseif { [regexp {^[0-9]} $arg]  } {
        quote "MODE [channel] -b [lindex [set ::[index]::banlist([string tolower [channel]])] [expr $arg - 1] ]"
        return 0
    } else {
        set nick [lindex [split $arg " "] 0]
        set umask [string tolower $nick![userhost $nick]]
    }
    foreach ban [set ::[index]::banlist([string tolower [channel]])] {
        if { [string match $umask [string tolower $ban]] || [string match [string tolower $ban] $umask] } {
            quote "mode [channel] -b $ban"
        }
    }
    return 0
}

# /unload <script>
#     Unloads the given script by deleting the script's namespace and calling
#     event_unload within the script.
alias unload {
    unscript $arg
}

# /untopic [<channel>]
#     Unsets the topic for the given, or current channel.
alias untopic {
    if { $arg=="" } { set arg [channel] }
    quote "TOPIC $arg :"
}

# /ver [<target>]
#     Sends a CTCP VERSION to the given nick or channel.  If no target is
#     specified, it will take send a version request to target as represented
#     by the current window.  If the window is the dcc files window, or the
#     server window, it will ask for the server version.
alias ver {
    if { $arg=="" } { set arg [windowname] }
    if { [currentwindow]==[pathname status] || [currentwindow]==[pathname files] } {
	quote "VERSION"
    } else {
	if { [string match =* $arg] } { set arg [string range $arg 1 end] }
	quote "PRIVMSG [lindex [split $arg " "] 0] :\x01VERSION\x01"
    }
}

proc alias_voice { arg } {
    quote "MODE [channel] +vvvvvv $arg"
}

# /w [<channel>]
#     Does a who on the given, or current, channel.
alias w {
    if { $arg=="" } { set arg [channel] }
    quote "WHO $arg"
}

proc alias_wall { arg } {
    quote "NOTICE @[channel] :\[\x002Qwall/[channel]\x002\] $arg"
    echo [currentwindow] 0 "\[\x002Qwall/[channel]\x002\] $arg"
}

# /wi [<nick> [<nick> ...]]
#     Does a whois on the given list of nicks.  If no nick is given, it will
#     use your nick.
alias wi {
    if { $arg=="" } {
	quote "whois [mynick]"
    } else { 
 	foreach user [split $arg] {
	    quote "WHOIS $user"
 	}
    }
}

# /wii [<nick> [<nick> ...]]
#     Does a whois (with idle time check) on the given list of nicks.  If no
#     nick is given, it will use your nick.
alias wii {
    if { $arg=="" } {
	quote "whois [mynick]"
    } else { 
 	foreach user [split $arg] {
	    quote "WHOIS $user $user"
 	}
    }
}

# PROCEDURES

# update_gblist <channel>
#     Updates the graphical banlist.  For use when the real banlist changes.
proc update_gblist { arg } {
    set chan [string tolower $arg]
    regsub \\. $chan -DOT- pathchan
    set bans  [set ::[index]::banlist($chan)]
    set bnicks  [set ::[index]::banwho($chan)]
    set btime ""
    foreach time [set ::[index]::bantime($chan)] {
	lappend btime [clock format $time]
    }

    .bans([index]+$pathchan).f.blist configure -width [string length [format " %-3s  %-[max 3 [llongest $bans]]s  %-[max 4 [llongest $bnicks]]s  %-[max 4 [llongest $btime]]s " "Num" "Ban" "Nick" "Time"]]

    for { set i 0 } { $i < [llength $bans] } { incr i } {
	.bans([index]+$pathchan).f.blist insert end [format " %-3s  %-[max 3 [llongest $bans]]s  %-[max 4 [llongest $bnicks]]s  %-[max 4 [llongest $btime]]s" [expr $i + 1] [lindex $bans $i] [lindex $bnicks $i] [lindex $btime $i]]
    }

    wm title .bans([index]+$pathchan) "Ban list for $arg \[[index]] ([llength $bans])"
    .bans([index]+$pathchan).top configure -text [format " %-3s  %-[max 3 [llongest $bans]]s  %-[max 4 [llongest $bnicks]]s  %-[max 4 [llongest $btime]]s" "Num" "Ban" "Nick" "Time"]
}
