# This file contains event handlers for join, kick, part, mode, quit, and nick
# that mute their output from the given channels.

#-The following variables are lists of channels to mute certain types of
#-activity from.

set muteall "#servhelp"

set mutejoin ""
set mutepart ""
set mutequit ""
set mutemode ""
set mutenick ""
set mutekick ""

# ALIASES

# /mute <type> <channel|clear>
#     Type is one of the following:
#         all
#         join
#         part
#         quit
#         mode
#         nick
#         kick
#     When a channel name is given, it is added to the list of chanels to mute.
#     When "clear" is given instead of a channel name, the mute list for that
#     particular type will be cleared.
alias mute {
    set args [split $arg " "]
    if { $arg=="" } {
	echo " \0030,14 MUTE \003 all is set to: [set ::[index]::killjpq::muteall]"
	echo " \0030,14 MUTE \003 join is set to: [set ::[index]::killjpq::mutejoin]"
	echo " \0030,14 MUTE \003 part is set to: [set ::[index]::killjpq::mutepart]"
	echo " \0030,14 MUTE \003 quit is set to: [set ::[index]::killjpq::mutequit]"
	echo " \0030,14 MUTE \003 mode is set to: [set ::[index]::killjpq::mutemode]"
	echo " \0030,14 MUTE \003 nick is set to: [set ::[index]::killjpq::mutenick]"
	echo " \0030,14 MUTE \003 kick is set to: [set ::[index]::killjpq::mutekick]"
	return
    }
    if { [llength $args]!=2 } {
	error "Usage: /mute <type> <channel|clear>"
    }
    set type [lindex $args 0]
    if { [lindex $args 1]=="clear" } {
	set ::[index]::killjpq::mute$type ""
	echo " \0030,14 MUTE \003 $type cleared"
    } elseif { $type=="all" || $type=="join" || $type=="part" || $type=="quit"
               || $type=="mode" || $type=="nick" || $type=="kick"} {
	echo " \0030,14 MUTE \003 $type set to: [lappend ::[index]::killjpq::mute$type [lindex $args 1]]"
    } else {
	error "/mute: Valid types include all, join, part, quit, mode, nick, and kick"
    }
}

proc event_join { prefix args } {
    set mute "[set ::[index]::killjpq::muteall] [set ::[index]::killjpq::mutejoin]"
    foreach channel $mute {
	if { [string tolower $channel]==[string tolower [lindex $args 0]] } {
	    return 3
	}
    }
}

proc event_kick { prefix args } {
    set mute "[set ::[index]::killjpq::muteall] [set ::[index]::killjpq::mutekick]"
    foreach channel $mute {
	if { [string tolower $channel]==[string tolower [lindex $args 0]] } {
	    return 3
	}
    }
}

proc event_part { prefix args } {
    set mute "[set ::[index]::killjpq::muteall] [set ::[index]::killjpq::mutepart]"
    foreach channel $mute {
	if { [string tolower $channel]==[string tolower [lindex $args 0]] } {
	    return 3
	}
    }
}

proc event_mode { prefix args } {
    set mute "[set ::[index]::killjpq::muteall] [set ::[index]::killjpq::mutemode]"
    foreach channel $mute {
	if { [string tolower $channel]==[string tolower [lindex $args 0]] } {
	    return 3
	}
    }
}

proc event_quit { prefix args } {
    set mute "[set ::[index]::killjpq::muteall] [set ::[index]::killjpq::mutequit]"
    foreach channel $mute {
	if { [ison [lindex [split $prefix "!"] 0] $channel] } {
	    return 3
	}
    }
}

proc event_nick { prefix args } {
    set mute "[set ::[index]::killjpq::muteall] [set ::[index]::killjpq::mutenick]"
    foreach channel $mute {
	if { [ison [lindex [split $prefix "!"] 0] $channel] } {
	    return 3
	}
    }
}
