# This is a QuIRC theme file.  It contains most of the code relating to what
# QuIRC looks like.  If you notice something that isn't in this file but should
# be, let me know.  The first part of the file is the global style config.  The
# second part is the event handling code that displays what comes from the
# server and such.  To load a different theme file, change the theme setting
# in config.tcl and restart QuIRC.  To get more information about the colors
# and options you can use, see the Tk man pages.  As a note, activeXXXXXXX is
# usually for when the mouse is over the item.  Things in this file should
# not be removed without care, as doing so may cause errors in the execution of
# the program.


# The following data gets inserted at the begining of the text boxes used
# for the channel/status/etc windows.  It is used to make the text insert
# starting at the bottom, not the top of the screen.
set ::pre_text_insertion "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"


# Lag Checker
set ::lag_foreground green
set ::lag_background black


# Default font settings to use throughout the file
set ::default_font_normal "-misc-fixed-medium-r-semicondensed-*-*-100-*-*-c-*-iso8859-1"
set ::default_font_bold "-misc-fixed-bold-r-semicondensed-*-*-100-*-*-c-*-iso8859-1"
#set ::default_font_normal "-adobe-courier-medium-r-normal-*-*-100-*-*-m-*-iso8859-1"
#set ::default_font_bold "-adobe-courier-bold-r-normal-*-*-100-*-*-m-*-iso8859-1"
#set ::default_font_normal "-*-clean-medium-r-*-*-*-120-*-*-*-*-*-*"
#set ::default_font_bold "-*-clean-bold-r-*-*-*-120-*-*-*-*-*-*"


# Window List Configuration
set ::windowlist_indent " "
# BW
set ::windowlist_background white
# BW
set ::windowlist_foreground black
set ::windowlist_activeforeground red
# BW
set ::windowlist_activebackground white
# BW
set ::windowlist_nonactiveforeground blue
# BW
set ::windowlist_nonactivebackground white
# BW
set ::windowlist_selectforeground black
# BW
set ::windowlist_selectbackground cyan
set ::windowlist_font $::default_font_normal
set ::windowlist_width 120


# The following colour definitions are used to define what the "mIRC colours"
# 0 through 15 map to in terms of real colour.  They would not normally be
# modified.  For example, if QuIRC or somebody on IRC sends a <color-code>4,
# it will use #ff0000 which is red.
set ::color(0) "#FFFFFF"
set ::color(1) "#000000"
set ::color(2) "#00007F"
set ::color(3) "#007F00"
set ::color(4) "#FF0000"
set ::color(5) "#7F0000"
set ::color(6) "#7F007F"
set ::color(7) "#FF7F00"
#set ::color(7) "#7F7F00"
set ::color(8) "#FFFF00"
set ::color(9) "#00FF00"
set ::color(10) "#007F7F"
set ::color(11) "#00FFFF"
set ::color(12) "#0000FF"
set ::color(13) "#FF00FF"
set ::color(14) "#7F7F7F"
set ::color(15) "#CFCFCF"
#set ::color(15) "#BFBFBF"


# Menu Bar and Menu Config

# The background to the menubar
#set ::menubar_background black

# The "File" menu text
#set ::menubutton_files_foreground white
#set ::menubutton_files_background black
#set ::menubutton_files_activeforeground white
#set ::menubutton_files_activebackground #00008b

# The items in the File menu
#set ::menu_files_foreground white
#set ::menu_files_background #00008b
#set ::menu_files_activeforeground white
#set ::menu_files_activebackground blue


# Button Bar Config

# The background to the menubar
set ::buttonbar_background black

# Forground and background of Connect/Disconnect button (including border)
set ::button_condis_foreground white
set ::button_condis_background #00008b
set ::button_condis_activeforeground white
set ::button_condis_activebackground blue
set ::button_condis_highlightbackground black

# Forground and background of close button (including border around button)
set ::button_close_foreground white
set ::button_close_background #00008b
set ::button_close_activeforeground white
set ::button_close_activebackground blue
set ::button_close_highlightbackground black


# These are the nicklist settings
set ::nicklist_side right
set ::nicklist_foreground white
set ::nicklist_background black
set ::nicklist_font $default_font_normal
set ::nicklist_width 15


# These are the banlist settings
set ::theme_banlist_font $default_font_normal
set ::theme_banlist_foreground lightblue
set ::theme_banlist_background black
set ::theme_banlist_title_foreground yellow
set ::theme_banlist_title_background $::theme_banlist_background
set ::theme_banlist_entry_foreground white
set ::theme_banlist_entry_background $::theme_banlist_background
set ::theme_banlist_entry_insertbackground $::theme_banlist_entry_foreground


# DCC Files Listbox settings
set ::filelist_foreground white
set ::filelist_background black
set ::filelist_font $default_font_normal

# Set up the text box colors and fonts

# Set up some defaults for easy changes to all window types at once
# These should be defined as numbers between 0 and 15
# BW
set ::default_foreground 1
# BW
set ::default_background 0
# Extra foreground/background settings
# BW
set ::default_foreground2 2
# BW
set ::default_foreground3 5
# The rest should be defined as normal Tk settings
set ::default_selectbackground grey
set ::default_selectforeground grey
set ::default_selectborderwidth 3
# BW
set ::default_entry_foreground black
# BW
set ::default_entry_background white
set ::default_entry_font $default_font_normal
set ::default_entry_insertbackground $default_entry_foreground

# Status window text color and font settings
set ::status_foreground $default_foreground
set ::status_background $default_background
set ::status_selectbackground $default_selectbackground
set ::status_selectforeground $default_selectforeground
set ::status_selectborderwidth $default_selectborderwidth
set ::status_font_normal $default_font_normal
set ::status_font_bold $default_font_bold

# Status entrybox settings
set ::status_entry_foreground $default_entry_foreground
set ::status_entry_background $default_entry_background
set ::status_entry_font $default_entry_font
set ::status_entry_insertbackground $default_entry_insertbackground

# Chat window text color and font settings
set ::chat_foreground $default_foreground
set ::chat_background $default_background
set ::chat_selectbackground $default_selectbackground
set ::chat_selectforeground $default_selectforeground
set ::chat_selectborderwidth $default_selectborderwidth
set ::chat_font_normal $default_font_normal
set ::chat_font_bold $default_font_bold

# Chat entrybox settings
set ::chat_entry_foreground $default_entry_foreground
set ::chat_entry_background $default_entry_background
set ::chat_entry_font $default_entry_font
set ::chat_entry_insertbackground $default_entry_insertbackground

# File window text color and font settings
set ::file_foreground $default_foreground
set ::file_background $default_background
set ::file_selectbackground $default_selectbackground
set ::file_selectforeground $default_selectforeground
set ::file_selectborderwidth $default_selectborderwidth
set ::file_font_normal $default_font_normal
set ::file_font_bold $default_font_bold

# File entrybox settings
set ::file_entry_foreground $default_entry_foreground
set ::file_entry_background $default_entry_background
set ::file_entry_font $default_entry_font
set ::file_entry_insertbackground $default_entry_insertbackground

# Main window text color and font settings
set ::main_foreground $default_foreground
set ::main_background $default_background
set ::main_selectbackground $default_selectbackground
set ::main_selectforeground $default_selectforeground
set ::main_selectborderwidth $default_selectborderwidth
set ::main_font_normal $default_font_normal
set ::main_font_bold $default_font_bold

# Main entrybox settings
set ::main_entry_foreground $default_entry_foreground
set ::main_entry_background $default_entry_background
set ::main_entry_font $default_entry_font
set ::main_entry_insertbackground $default_entry_insertbackground

# Channel window text color and font settings
set ::channel_foreground $default_foreground
set ::channel_background $default_background
set ::channel_selectbackground $default_selectbackground
set ::channel_selectforeground $default_selectforeground
set ::channel_selectborderwidth $default_selectborderwidth
set ::channel_font_normal $default_font_normal
set ::channel_font_bold $default_font_bold

# Channel entrybox settings
set ::channel_entry_foreground $default_entry_foreground
set ::channel_entry_background $default_entry_background
set ::channel_entry_font $default_entry_font
set ::channel_entry_insertbackground $default_entry_insertbackground

# Query window text color and font settings
set ::query_foreground $default_foreground
set ::query_background $default_background
set ::query_selectbackground $default_selectbackground
set ::query_selectforeground $default_selectforeground
set ::query_selectborderwidth $default_selectborderwidth
set ::query_font_normal $default_font_normal
set ::query_font_bold $default_font_bold

# Query entrybox settings
set ::query_entry_foreground $default_entry_foreground
set ::query_entry_background $default_entry_background
set ::query_entry_font $default_entry_font
set ::query_entry_insertbackground $default_entry_insertbackground

proc ::display { type args } {
    switch $type {
	"dns_error" {
	    echo " \0030,6 ERROR \003 [lindex $args 0]" .main
	}
	"dns_for" {
	    echo " \0030,14 DNS \003 Info for [lindex $args 0]:" .main
	}
	"dns_hostname" {
	    echo " \0030,14 DNS \003 Host name: [lindex $args 0]" .main
	}
	"dns_ip" {
	    echo " \0030,14 DNS \003 IP Address: [lindex $args 0]" .main
	}
	default {
	    error "No display section present for $type ($args).  You may have forgotten to run quirc.inst to replace style.tcl with the new version."
	}
    }
}

if { [namespace current]=="::" } { return }


# Server Specific Section

proc ::[index]::display { type args } {
    switch $type {
	"connect_attempt" {
	    echo " \0030,14 STATUS \003 Attempting connection to [lindex $args 0]" [pathname all] 0
	}
	"dcc_error" {
	    echo " \0030,5 ERROR \003 [lindex $args 1]: [lindex $args 2]" [lindex $args 0]
	}
	"dcc_file_error" {
	    echo " \[[lindex $args 0]] \0030,5 ERROR \003 [lindex $args 1]: [lindex $args 2]" [pathname files]
	}
	"script_load" {
	    echo " \0030,4 SCRIPT \003 Loading\003$::default_foreground2 [lindex $args 0]\003 into namespace\003$::default_foreground2 [lindex $args 1]" [pathname status]
	}
	"no_mode_parameter" {
	    if { [lindex $args 0] } { set char "+" } else { set char "-" }
	    echo " \0030,5 ERROR \003 No parameter given for mode change $char[lindex $args 1].  This is likely due to a bug in the IRCd.  If you don't believe it to be the IRCd's fault, please contact patearl@pobox.com with an explaination.  Sending a channel mode request to ensure correct modes." [pathname status]
	}
	default {
	    error "No display section present for $type ($args).  You may have forgotten to run quirc.inst to replace style.tcl with the new version."
	}
    }
}

proc event_connect {} {
    echo " \0030,14 STATUS \003 Connected." [pathname all] 0
}

proc event_dcc_connect { pathname nick ip port type args } {
    if {$type!="chat"} { set pathname ".files[index]" }
    if {$type!="filesend" && $type!="fileget"} {
	echo " \0030,14 DCC \003 Connected." $pathname
    }
    if {$type=="filesend"} {
	set pathfile [lindex $args 0]
	set file [lindex $args 1]
	set size [lindex $args 2]
	set index [lindex $args 3]
	set entryindex [lindex $args 4]
	$pathname.list delete $entryindex $entryindex
	$pathname.list insert $entryindex " \[$index] Connected... Waiting for transfer"
	echo " \[$index] \0030,14 DCC \003 Connected." $pathname
	echo " \[$index] Transfering\0032 $pathfile\003 as\0032 $file\003 (\00302$size\003 bytes)" $pathname
    }
    if {$type=="fileget"} {
	set pathfile [lindex $args 0]
	set file [lindex $args 1]
	set size [lindex $args 2]
	set index [lindex $args 3]
	set entryindex [lindex $args 4]
	if { $size==0 } {
	    set size "???"
	}
	$pathname.list delete $entryindex $entryindex
	$pathname.list insert $entryindex " \[$index] Connected... Waiting for transfer"
	echo " \[$index] \0030,14 DCC \003 Connected." $pathname
	echo " \[$index] Recieving\0032 $file\003 to\0032 $pathfile\003 (\00302$size\003 bytes)" $pathname
    }
    return 2;
}

proc event_dcc_getstatus { entryindex nick pathfile file written size index } {
    set pathname ".files[index]"
    $pathname.list delete $entryindex $entryindex
    if { $size } {
	$pathname.list insert $entryindex " \[$index] Getting \"$file\" from $nick.  [expr int($written/($size+0.0)*100)]% ($written)"
    } else {
	$pathname.list insert $entryindex " \[$index] Getting \"$file\" from $nick.  ???% ($written)"
    }
    return 2;
}

proc event_dcc_sendstatus { entryindex nick pathfile file acknowledged transmitted size index } {
    set pathname ".files[index]"
    $pathname.list delete $entryindex $entryindex
    $pathname.list insert $entryindex " \[$index] Sending \"$file\" to $nick.  [expr int($acknowledged/($size+0.0)*100)]% ($acknowledged)"
    return 2;
}

proc event_dcc_text { nick text } {
    if { [string range $text 0 7]=="\001ACTION " } {
	if { [string index $text [expr [string length $text]-1]]=="\001" } {
	    set text [string range $text 8 [expr [string length $text]-2]]
	} else {
	    set text [string range $text 8 end]
	}
	echo "\0032* $nick $text" [pathname chat $nick] 1
    } else {
	echo "\0032<$nick>\003 $text" [pathname chat $nick] 1
    }
    return 2;
}

proc event_disconnect {} {
    if { [currentindex]==[index] } {
	.buttonbar.condis configure -command "connect" -text "Connect"
    }
    echo " \0030,14 STATUS \003 Disconnected." [pathname all] 0
}

proc event_error { prefix args } {
    echo " \0030,13 ERROR \003 [join $args]" [pathname all] 0
    return 2
}

proc event_invite { prefix args } {
    echo [pathname status] 1 " \0030,7 INVITE \003 [lindex $args 1] from $prefix"
    return 2
}

proc event_join { prefix args } {
    if { [mynick]==[lindex [split $prefix "!"] 0] } {
	createchannel [lindex $args 0]
	echo [pathname channel [lindex $args 0]] 0 " \0030,3 JOIN \003 $prefix"
    } else {
	if { [onchannel [lindex $args 0]] } {
	    echo " \0030,3 JOIN \003 $prefix" [pathname channel [lindex $args 0]]
	}
    }
    return 2
}

proc event_kick { prefix args } {
    if { [onchannel [lindex $args 0]] } { echo [pathname channel [lindex $args 0]] 0 " \0030,13 KICK \003 [lindex $args 1] by $prefix ([lindex $args 2])" }
    return 2
}

proc event_mode { prefix args } {
    if { [ischannel [lindex $args 0]] } {
	if { [onchannel [lindex $args 0]] } {
	    echo [pathname channel [lindex $args 0]] 1 " \0030,12 MODE \003 \"[join [lrange $args 1 end]]\" by $prefix"
	}
    } else {
	echo [pathname status] 1 " \0030,12 MODE \003 \"[lindex $args 1]\""
    }
    return 2
}

proc event_nick { prefix args } {
    set nick [lindex [split $prefix "!"] 0]
    set text " \0030,10 NICK \003 $nick is now known as [lindex $args 0]"
    if { $nick==[mynick] } {
	echo [pathname status] 1 $text
    }
    if { [mynick]!=$nick } {
	foreach channel [channels] {
	    if { [ison $nick $channel] } {
		echo [pathname channel $channel] 1 $text
	    }
	}
	if { [pathname query $nick]!="" } {
	    echo [pathname query $nick] 1 $text
	}
    } else {
	foreach channel [channels] {
	    echo [pathname channel $channel] 0 $text
	}
	foreach query [queries] {
	    echo [pathname query $query] 0 $text
	}
    }
    return 2
}

proc event_notice { prefix args } {
    set nick [lindex [split $prefix "!"] 0]
    set message [lindex $args 1]
    if { [string index $message 0]=="\x01" } {
	if { [string index $message [expr [string length $message]-1]]=="\x01" } {
	    set message [string range $message 1 [expr [string length $message]-2]]
	} else {
	    set message [string range $message 1 end]
	}
	set data [join [lrange [split $message " "] 1 end]]
	switch -- [string toupper [lindex [split $message " "] 0]] {
	    "PING" {
		if { [regexp {^[0-9]+\.[0-9]+$} $data] } {
		    echo [pathname status] 1 " \0030,10 CTCP-REPLY \003\0035 PING\003 from\0032 $nick\003: [format "%.3f" [expr [microtime]-$data]]\003 seconds"
		} else {
		    if { $data!="" } {
			echo [pathname status] 1 " \0030,10 CTCP-REPLY \003\0035 [lindex [split $message " "] 0]\003 from\0032 $nick\003: $data"
		    } else {
			echo [pathname status] 1 " \0030,10 CTCP-REPLY \003\0035 [lindex [split $message " "] 0]\003 from\0032 $nick\003"
		    }
		}
		return 2
	    }
	    default {
		if { $data!="" } {
		    echo [pathname status] 1 " \0030,10 CTCP-REPLY \003\0035 [lindex [split $message " "] 0]\003 from\0032 $nick\003: $data"
		} else {
		    echo [pathname status] 1 " \0030,10 CTCP-REPLY \003\0035 [lindex [split $message " "] 0]\003 from\0032 $nick\003"
		}
		return 2
	    }
	}
    } else {
	set target [lindex $args 0]
	if { [string match "*.*" $nick]} {
	    echo "\003$::default_foreground2-$prefix-\003 [lindex $args 1]" [pathname status]
	} elseif { $nick=="" } {
	    echo "[lindex $args 1]" [pathname status]
	} else {
	    if { !([ischannel [lindex $args 0]]&&![onchannel [lindex $args 0]]) } {
		if { [string index $target 0] == "@"} { set target [string range $target 1 end] }
		if { [ischannel [string tolower $target]] } {
		    if { [string index [lindex $args 0] 0] == "@"} {
			echo "\0036-$nick-\003 [lindex $args 1]" [pathname channel [string tolower $target]]
		    } else {
			echo "\0032-\([lindex $args 0]\)-$nick-\003 [lindex $args 1]" [pathname channel [string tolower $target]]
		    }
		} else {
		    if { ( $nick == "MemoServ" || $nick == "ChanServ" || $nick == "NickServ" ) && $::dynamic::echo_services_to_status == 1 } {
			echo [pathname status] 1 "\0032-$nick-\003 [lindex $args 1]"
		    } else {
			if { [index]==[currentindex] } {
			    echo "\003$::default_foreground2-$nick-\003 [lindex $args 1]"
			} else {
			    echo "\003$::default_foreground2-$nick-\003 [lindex $args 1]" [pathname status]
			}
		    }
		}
	    }
	}
	return 2
    }
}

proc event_part { prefix args } {
    if { [onchannel [lindex $args 0]] } {
	if { [lindex $args 1]!="" } {
	    echo [pathname channel [lindex $args 0]] 1 " \0030,4 PART \003 $prefix ([lindex $args 1])"
	} else {
	    echo [pathname channel [lindex $args 0]] 1 " \0030,4 PART \003 $prefix"
	}
    }
    return 2
}

proc event_pong { prefix args } {
    if { [regexp {^[0-9]+\.[0-9]+$} [lindex $args 1]] } {
	set lagtime [expr [microtime]-[lindex $args 1]]
	set ::[index]::lagtext [format "Server Lag: %5.2f" $lagtime]
	if { [currentindex]==[index] } {
	    .buttonbar.lag configure -text [format "Server Lag: %5.2f" $lagtime]
	}
	if { $::dynamic::lag_time!=0 } {
	    if { $lagtime>$::dynamic::lag_time } {
		quote "PING [microtime]"
	    } else {
		after [expr int(($::dynamic::lag_time-$lagtime)*1000)] "::template::quote [index] \"PING \[microtime]\""
	    }
	}
    } else {
	echo " \0030,6 PONG \003 [join $args]"
    }
    return 2
}

proc event_privmsg { prefix args } {
    set nick [lindex [split $prefix "!"] 0]
    set message [lindex $args 1]
    
    set opmessage 0
    set target ""
    if { [ischannel [lindex $args 0]] } {
	set target [lindex $args 0]
    }
    if { [string index [lindex $args 0] 0]=="@" } {
	set opmessage 1
	set target [string range [lindex $args 0] 1 end]
    }
    if { [string index $message 0]=="\x01" } {
	if { [string index $message [expr [string length $message]-1]]=="\x01" } {
	    set message [string range $message 1 [expr [string length $message]-2]]
	} else {
	    set message [string range $message 1 end]
	}
	set data [join [lrange [split $message " "] 1 end]]
	switch -- [string toupper [lindex [split $message " "] 0]] {
	    "ACTION" {
		if { $opmessage } {
		    set text "\0036* $nick $data"
		} else {
		    set text "\003$::default_foreground2* $nick $data"
		}
	    }
	    default {
		if {$opmessage} { set thecolor 6 } else { set thecolor 10 }
		if { $target!="" } {
		    set pathname [pathname channel $target]
		} else {
		    set pathname [pathname status]
		}
		if { $data!="" } {
		    echo " \0030,$thecolor CTCP \0035,0 [lindex [split $message " "] 0]\003 from\0032 $nick\003: $data" $pathname
		    return 2
		} else {
		    echo " \0030,$thecolor CTCP \0035,0 [lindex [split $message " "] 0]\003 from\0032 $nick\003" $pathname
		    return 2
		}
	    }
	}
    } else {
	if { $opmessage } {
	    set text "\0036<$nick>\003 $message"
	} else {
	    set text "\003$::default_foreground2<$nick>\003 $message"
	}
    }
    if { $target!="" } {
	if { [onchannel $target] } {
	    echo $text [pathname channel $target]
	}
    } else {
	createquery $nick
	echo [pathname query $nick] 1 $text
    }
    return 2
}

proc event_quit { prefix args } {
    set nick [lindex [split $prefix "!"] 0]
    set text " \0030,5 QUIT \003 $prefix ([lindex $args 0])"
    foreach channel [channels] {
	if { [ison $nick $channel] } {
	    echo [pathname channel $channel] 1 $text
	}
    }
    if { [pathname query $nick]!="" } {
	echo [pathname query $nick] 1 $text
    }
    return 2
}

proc event_topic { prefix args } {
    title [pathname [lindex $args 0]] "QuIRC - [lindex $args 0] ([lindex $args 1])"
    if { [onchannel [lindex $args 0]] } {
	echo [pathname channel [lindex $args 0]] 1 " \0030,7 TOPIC \003 \"[lindex $args 1]\" by $prefix"
    }
    return 2
}

proc event_wallops { prefix args } {
    echo [pathname status] 1 " \0030,3 WALLOPS \003\0032 $prefix\003: [lindex $args 0]"
    return 2
}

# Away response
proc event_301 { prefix args } {
    echo " \0030,10 AWAY \003 [lindex $args 1] ([join [lrange $args 2 end]])" [pathname status] 1
    return 2
}

# ISON list
proc event_303 { prefix args } {
    echo [pathname status] 1 " \0030,10 ISON-LIST \003 [lindex $args 1] "
    return 2
}

# event_305
#     "You are no longer marked as being away"
proc event_305 { args } {
    echo " \0030,10 BACK \003 [lindex $args 2]" [pathname status]
    return 2
}

# event_306
#     "You have been marked as being away"
proc event_306 { args } {
    echo " \0030,10 AWAY \003 [lindex $args 2]" [pathname status]
    return 2
}

# HelpOp part of WHOIS response
proc event_310 { prefix args } {
    echo " \0030,10 WHOIS \003 help      : [join [lrange $args 1 end]]" [pathname status] 1
    return 2
}

# Nick/Userhost part of WHOIS response
proc event_311 { prefix args } {
    set cc [string toupper [string range [lindex $args 3] [expr [string last . [lindex $args 3]] + 1] end]]
    if { ![is_ip_addr [lindex $args 3]] && [array names ::country $cc]!="" } {
	set cnt [string tolower $::country($cc)]
    } else { set cnt "unknown" }
    
    echo " \0030,10 WHOIS \003 nick,host : \002[lindex $args 1]\002 \00314\002(\002\0031[lindex $args 2]@[lindex $args 3]\00314\002)\002\0031 ($cnt)" [pathname status] 1
    echo " \0030,10 WHOIS \003 ircname   : [join [lrange $args 5 end]]" [pathname status] 1
    return 2
}

# Server part of WHOIS response
proc event_312 { prefix args } {
    echo " \0030,10 WHOIS \003 server    : [lindex $args 2] ([join [lrange $args 3 end]])" [pathname status]
    return 2
}

# Oper part of WHOIS response
proc event_313 { prefix args } {
    echo " \0030,10 WHOIS \003 operator  : [join [lrange $args 1 end]]" [pathname status]
    return 2
}

# End of WHO reply
proc event_315 { prefix args } {
    set chan [string tolower [lindex $args 1]]
    upvar ::[index]::wlistq wlistq
    if { [lsearch -exact $wlistq $chan] >= 0 } { 
	set ::[index]::wlistq [lreplace $wlistq [lsearch -exact $wlistq $chan] [lsearch -exact $wlistq $chan]]
    } else {
	echo [pathname status] 1 " \0030,10 WHO-LIST \003\0032 End of WHO list for [lindex $args 1]"
    }
    return 2
}

# Idle/Signon time part of WHOIS response
proc event_317 { prefix args } {
    set so [lindex $args 3]
    set i [lindex $args 2]
    set days 0
    set hours 0
    set mins 0
    if { $i > 86399 } {
	set days [expr $i / 86400]
	set i [expr $i - $days * 86400]
    }
    if { $i > 3599 } {
	set hours [expr $i / 3600]
	set i [expr $i - $hours * 3600]
    }
    if { $i > 59 } {
	set mins [expr $i / 60]
	set i [expr $i - $mins * 60]
    }
    set daystr "" 
    set hourstr ""
    set minstr ""
    set secstr ""
    
    if { $days != 0 } { set daystr "$days days " }
    if { $hours != 0 } { set hourstr "$hours hours " }
    if { $mins != 0 } { set minstr "$mins minutes " }
    if { $i != 0 || ($mins == 0 && $hours == 0 && $days == 0)} { set secstr "$i seconds" }
    if { $days == 1 } { set daystr "$days day " }
    if { $hours == 1 } { set hourstr "$hours hour " }
    if { $mins == 1 } { set minstr "$mins minute " }
    if { $i == 1 } { set secstr "$i second" }
    echo " \0030,10 WHOIS \003 idle      : $daystr$hourstr$minstr$secstr. Signon: [clock format $so]" [pathname status] 1
    return 2
}

# End of WHOIS response
proc event_318 { prefix args } {
    return 2
}

# Channels part of WHOIS response
proc event_319 { prefix args } {
    echo " \0030,10 WHOIS \003 channels  : [join [lrange $args 2 end]]" [pathname status]
    return 2
}

# Current MODE of channel
proc event_324 { prefix mynick channel args } {
    echo " \0030,12 MODE \003 \"[join $args]\"" [pathname channel $channel]
    return 2
}

# event_328
#     Channel URL
proc event_328 { args } {
    if { [lsearch -exact [string tolower [channels]] [string tolower [lindex $args 2]]]!=-1} {
	echo " \0030,10 URL \003 [lindex $args 3]" [pathname channel [lindex $args 2]]
    } else {
	echo " \0030,10 URL \003 [lindex $args 2]: [lindex $args 3]" [pathname status]
    }
    return 2
}

# Channel creation date
proc event_329 { prefix mynick channel time } {
    echo " \0030,10 CREATED \003 [clock format $time]" [pathname channel $channel]
    return 2
}

# Reply to TOPIC query
proc event_332 { prefix args } {
    title [pathname [lindex $args 1]] "QuIRC - [lindex $args 1] ([lindex $args 2])"
    if { [onchannel [lindex $args 1]] } {
	echo [pathname channel [lindex $args 1]] 1 " \0030,7 TOPIC \003 \"[lindex $args 2]\""
    }
    return 2
}

# Date and nick reply to TOPIC query
proc event_333 { prefix args } {
    if { [onchannel [lindex $args 1]] } {
	echo [pathname channel [lindex $args 1]] 1 " \0030,7 TOPIC \003 Set by [lindex $args 2] on [clock format [lindex $args 3]]"
    }
    return 2
}


# Succesful reply to INVITE
proc event_341 { prefix args } {
    echo [pathname status] 1 " \0030,7 INVITE \003 [lindex $args 1] to [lindex $args 2]"
    return 2
}


set ::[index]::wlistq ""

# Reply to WHO
proc event_352 { prefix args } {
    upvar ::[index]::wlistq wlistq
    if { [lsearch -exact $wlistq [string tolower [lindex $args 1]]] == -1 } {
	echo " \0030,10 WHO-LIST \003\0032 [lindex $args 1] \0031,08[lindex $args 6]\003\00312 [lindex $args 5]\0031!\00312[lindex $args 2]@[lindex $args 3] \0031\(\0032[join [lrange [split [lindex $args 7] " "] 1 end]]\0031\) [lindex $args 4]\[[lindex [split [lindex $args 7] " "] 0]\]" [pathname status]
    }
    return 2
}

# event_372
#     MOTD Body
proc event_372 { args } {
    echo " \0030,7 MOTD \003 [lindex $args 2]" [pathname status]
    return 2
}

# event_375
#     MOTD Start
proc event_375 { args } {
    echo " \0030,7 MOTD \003 [lindex $args 2]" [pathname status]
    return 2
}

# event_376
#     MOTD End
proc event_376 { args } {
    echo " \0030,7 MOTD \003 [lindex $args 2]" [pathname status]
    return 2
}

# event_401
#     No such nick error
proc event_401 { args } {
    echo " \0030,6 OOPS \003 [lindex $args 3]: [lindex $args 2]" [pathname status]
    return 2
}

# event_403
#     No such channel error (/mode #nonexistant to test.)
proc event_403 { args } {
    echo " \0030,6 OOPS \003 [lindex $args 3]: [lindex $args 2]" [pathname status]
    return 2
}

# event_421
#     Invalid command error
proc event_421 { args } {
    echo " \0030,6 OOPS \003 [lindex $args 3]: [lindex $args 2]" [pathname status]
    return 2
}

# event_441
#     User is not on channel (/mode #existant +o not_in_channel_existant to
#     test.)
proc event_441 { args } {
    echo " \0030,6 OOPS \003 [lindex $args 2] [lindex $args 3] [lindex $args 4]" [pathname status]
    return 2
}

# Numerics not parsed by any script commands or within QuIRC's internals
proc event_unparsednumeric { prefix command args } {
# BW
    echo [pathname status] 1 " \0030,1 $command \003 [join [lrange $args 1 end]]"
    return 2
}

# Anything not parsed by previous script, or within QuIRC's internals
proc event_unparsed { prefix command args } {
    echo [pathname status] 1 " \0034,1 $command \003 ($prefix) [join [lrange $args 0 end]]"
    return 2
}
